/*  
 *  main.c -- ukzka programu s chybou!
 *
 *  demonstrace nutnosti pouvat prototypy funkc v ISO C
 *
 *  Nzorn ukzka co doke chybn proveden modularita:
 *
 *  Bez prototypu peklada neme tm nic zkontrolovat.
 *  Chovn viz ISO C99 (6.5.2.2 paragraf 6). 
 *  Peklada me hlsit chybu nebo pouze varovn - podrobnosti
 *  viz C99 Rationale - sekce 6.5.2.2.
 *
 */

/* ZDE CHYB #include ROZHRAN modulu obsahujcho definici funkce f() */

#include <stdio.h>		/* prototyp  int printf(const char *, ...)   */

int main()
{				/* funkce main mus bt jen jedna            */

    printf("Pklad chyby pi voln funkce bez prototypu\n");
    printf("Voln f(x) m sprvn vrtit hodnotu argumentu x\n\n");

    /* pi voln bez prototypu peklada implicitn pedpokld: int f()    */
    /* ale funkce je ve skutenosti: double f(double)                        */

    printf("int i = f(1);\n");
    int i = f(1);		/* CHYBA: parametr i nvratov hodnota       */
    printf("i = %d\n", i);

    printf("double d = f(1.0);\n");
    double d = f(1.0);		/* CHYBA: nvratov hodnota                  */
    printf("d = %g\n", d);

    return 0;
}
